BANDED_TRANS_SAMPLER mys;

spork ~ mys.recordSomething(30::second);
30::second => now;

/// send a signal 

[ .9, 0.5, .5, .1, 
.7, .1, .3, .1, 
.9, .3, .6, .6, 
0.7, .6, .5, .7 ] @=> float patternLow[];

[ .0, 0.6, .5, .0, 
.8, .1, .3, .6, 
0, .3, .5, .4, 
0.9, .3, .6, .1 ] @=> float patternMid[];

[ 0.9, 0.6, .9, .7, 
.9, .6, .9, .1, 
.9, .8, .9, .8, 
0.9, .6, .9, .8 ] @=> float patternHi[];


    0 => int i;
    0. => float density;
    0.1 => float densityShort;
    0.1 => float densityLong;
    
    Envelope densityEnv => blackhole;
    0.0 => density => densityEnv.value;
    
    fun void denseLFO(){
        while(1){
            1 + .5 * Math.sin( now/second * .5) => density;
            10::ms => now;
        }
    }
    
    fun void densityTrackRMS(){
        while(1)
        {
            2 * RMS_TRACKER.rmsSum => density;
            2 * RMS_TRACKER.rmsSumShort => densityShort;
            2 * RMS_TRACKER.rmsSumLong => densityLong;
            10::ms=> now;
        }
    }
    
    fun void rampDensity(float target, dur howLong){
        <<<"rampDensity">>>;
        howLong => densityEnv.duration;
        target => densityEnv.target;
        <<<densityEnv.target()>>>;
        while(densityEnv.value() != target){
            densityEnv.value() => density;
            // <<<densityEnv.value()>>>;
            10::ms => now;
        }
    }
    //spork~densityTrackRMS();
    //spork ~denseLFO();
    spork~ rampDensity(.5, 20::second);
    
    20::second + now => time later;
    0 => int notYet;
    
    while (1){
        if (!notYet && now > later)
        {
            1 => notYet;
            spork ~ densityTrackRMS();
        }
        if ((1-density) < patternLow[i] ){
            //<<<"low", density>>>;
            spork ~ mys.playLow();
        }
        if ((1-density) < patternMid[i] ){
            //<<< "mid", densityShort>>>;
            spork ~ mys.playMid();
        }
        //<<< (1 - densityLong), patternHi[i]>>>;
        if ((1-density) < patternHi[i] ){
            //<<< "hi", densityLong>>>;
            spork ~ mys.playHi();
        }
        i++;
        16 %=> i;
        //200::ms => now;
        Metro.beat => now;
        Metro.beat.signal();
    }