public class CENTROID{
    // our patch
    adc => FFT fft =^ Centroid cent => blackhole;
    
    // set parameters
    512 => fft.size;
    // set hann window
    Windowing.hann(512) => fft.window;
    
    static float centVal;
    // compute srate
    second / samp => float srate;
    
    fun dur getUpdateRate(){
        return fft.size()::samp;
    }
    
    // control loop
    fun void calcCentroid(){
        while( true )
        {
            // upchuck: take fft then centroid
            cent.upchuck();
            // print out centroid
            //<<< cent.fval(0) * srate / 2 >>>;
            cent.fval(0) * srate / 2 => centVal;
            // advance time
            fft.size()::samp => now;
        }
    }
}
CENTROID troid;
0. => CENTROID.centVal;
spork ~ troid.calcCentroid();
1::day=> now;