// signal chain
adc => Envelope e => LiSa loopme => dac;
adc => Gain g => dac;

5::second => loopme.duration;
20::ms => dur fadetime;
5::second => dur looplen;
fadetime => e.duration;
// record
loopme.record(1);

e.keyOn();
now + (looplen - fadetime) => time later;

while(now < later){
    10::ms => now;
}
e.keyOff();
// stop!
loopme.record(0);
// unplug
adc =< g;

0 => int vPtr;
4 => int numVoices;
int voice[numVoices];

fun void playSomething(int v, dur loc){
    // get a voice and assign it to the next in the array
    loopme.getVoice() => voice[vPtr];
    //
    <<< loc >>>;
    loopme.playPos(voice[v], loc);
    // play
    loopme.play(voice[v], 1);
    200::ms => now;
    // stop
    loopme.play(voice[v], 0);
}


// get an available voice
for (0 => int i; i < 20*numVoices; i++){
    spork ~ playSomething(vPtr, Std.rand2f(0.0, 4.0)::second);
    vPtr++;
    numVoices %=> vPtr;
    50::ms => now;
}


